- [HTTP request](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/batchGet#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/batchGet#body.PATH_PARAMETERS)
- [Query parameters](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/batchGet#body.QUERY_PARAMETERS)
- [Request body](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/batchGet#body.request_body)
- [Response body](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/batchGet#body.response_body)
  - [JSON representation](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/batchGet#body.BatchGetValuesResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/batchGet#body.aspect)
- [Try it!](https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/batchGet#try-it)

Returns one or more ranges of values from a spreadsheet. The caller must specify the spreadsheet ID and one or more ranges.

### HTTP request

`GET https://sheets.googleapis.com/v4/spreadsheets/{spreadsheetId}/values:batchGet`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `spreadsheetId` | `string` The ID of the spreadsheet to retrieve data from. |

### Query parameters

| Parameters ||
|---|---|
| `ranges[]` | `string` The [A1 notation or R1C1 notation](https://developers.google.com/workspace/sheets/api/guides/concepts#cell) of the range to retrieve values from. |
| `majorDimension` | ``enum (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/Dimension`)`` The major dimension that results should use. For example, if the spreadsheet data is: `A1=1,B1=2,A2=3,B2=4`, then requesting `ranges=["A1:B2"],majorDimension=ROWS` returns `[[1,2],[3,4]]`, whereas requesting `ranges=["A1:B2"],majorDimension=COLUMNS` returns `[[1,3],[2,4]]`. |
| `valueRenderOption` | ``enum (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/ValueRenderOption`)`` How values should be represented in the output. The default render option is `https://developers.google.com/workspace/sheets/api/reference/rest/v4/ValueRenderOption#ENUM_VALUES.FORMATTED_VALUE`. |
| `dateTimeRenderOption` | ``enum (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/DateTimeRenderOption`)`` How dates, times, and durations should be represented in the output. This is ignored if `https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values/batchGet#body.QUERY_PARAMETERS.value_render_option` is `https://developers.google.com/workspace/sheets/api/reference/rest/v4/ValueRenderOption`. The default dateTime render option is `https://developers.google.com/workspace/sheets/api/reference/rest/v4/DateTimeRenderOption`. |

### Request body

The request body must be empty.

### Response body

The response when retrieving more than one range of values in a spreadsheet.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "spreadsheetId": string, "valueRanges": [ { object (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values#ValueRange`) } ] } ``` |

| Fields ||
|---|---|
| `spreadsheetId` | `string` The ID of the spreadsheet the data was retrieved from. |
| `valueRanges[]` | ``object (`https://developers.google.com/workspace/sheets/api/reference/rest/v4/spreadsheets.values#ValueRange`)`` The requested values. The order of the ValueRanges is the same as the order of the requested ranges. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/drive`
- `https://www.googleapis.com/auth/drive.readonly`
- `https://www.googleapis.com/auth/drive.file`
- `https://www.googleapis.com/auth/spreadsheets`
- `https://www.googleapis.com/auth/spreadsheets.readonly`

For more information, see the [Authorization guide](https://developers.google.com/workspace/guides/configure-oauth-consent).